//  Objectif : Dfinir une classe Date (trs, trs simplifie).
//
//  Principe :
//	Une date est dfinie par un jour, un mois et une anne et :
//	- oprations de comparaison

#include <iostream>
using namespace std;

// Dfinition d'une date.
//
class Date  {
public:

// constructeurs

    Date(short jj, short mm, int aa); 
	// construire une date  partir d'un jour jj, d'un mois mm et
	// d'une anne aa.

// destructeur

    ~Date();
	// Destructeur.
	//
	// Dans le cas prsent, le dfinir n'tait pas ncessaire.
	// ... sauf pour tracer les destructions de date !

// Requtes : information sur l'objet (ou la classe)

    short jour() const;
	// le jour de la date

    short mois() const;
	// le mois de la date

    int annee() const;
	// l'anne de la date

// Commandes : services rendus par l'objet

    void  set(short jj, short mm, int aa);
	// mettre  jour la date  partir d'un jour jj, d'un mois
	// mm et d'une anne aa.

    void afficher(ostream & out = cout) const;
	// afficher une date sur le flt de sortie out

// Oprations de comparaison entre les dates (dfinies comme
// fonctions membres)

    bool lt(const Date &d2) const;		// *this <  d2
	// est-ce que la date est strictement antrieure  la date d2

// Opration de comparaison lt dfinie comme fonction de classe
    
    static bool lt(const Date & d1, const Date & d2);

    bool ge(const Date &d2) const;		// *this >= d2
	// est-ce que la date est postrieure  la date d2

    bool gt(const Date &d2) const;		// *this >  d2
	// est-ce que la date est strictement postrieure  la date d2

    bool le(const Date &d2) const;		// *this <= d2
    bool eq(const Date &d2) const;		// *this == d2
    bool neq(const Date &d2) const;		// *this != d2

private:

    // Nous dfinissons ici les attributs qui correspondent 
    // l'tat d'un objet Date

    short _jour;	// le numro du jour dans le mois
    short _mois;	// le numro du mois dans l'anne
    int _annee;	// le numro de l'anne
};

// Opration de comparaison lt dfinie en dehors de la classe
bool lt(const Date & d1, const Date & d2);
